#Runs the 6 homeworks and gives back any errors encountered
#5/14/2003 - Adam Wilson

import os
import urllib

######################################################
# Function: regTest()
# Description:
#    Executes six homeworks from Spring2003 CS1315 for
#    testing purposes.  It will catch and print out any
#    errors without stopping.
#    Feel free to make the exception descriptions better...
###################################################### 
def regTest():
  setMediaPath()

  #try homework 1: 
  try:
    hw1(makePicture(getMediaPath("flower1.jpg")))
    printNow("HW 1 executed correctly") 
  except Exception, desc:
    printNow("Error on HW 1:")
    printNow(desc)
  printNow("_")

  #try homework 2:
  try:
    hw2(getMediaPath("preamble10.wav"))
    printNow("HW 2 executed correctly" )
  except Exception, desc:
    printNow("Error on HW 2:")
    printNow(desc)
  printNow("_")

  #try homework 3:
  try:
    hw3()
    printNow("HW 3 executed correctly") 
  except Exception, desc:
    printNow("Error on HW 3:")
    printNow(desc)
  printNow("_")

  #try Homework 4:
  try:
    hw4(getMediaPath("ImageFolder"))
    printNow("HW 4 executed correctly") 
  except Exception, desc:
    printNow("Error on HW 4:")
    printNow(desc)
  printNow("_")

  #try homework 5:
  try:
    hw5(getMediaPath("HW5Folder"))
    printNow("HW 5 executed correctly")
  except Exception, desc:
    printNow("Error on HW 5:")
    printNow(desc)
  printNow("_")

  #try homework 6:
  try:
    hw6(getMediaPath("HW6Folder"))
    printNow("HW 6 executed correctly")
  except Exception, desc:
    printNow("Error on HW 6:")
    printNow(desc)
  printNow("_")

######################################################
# Homework 1:
# shows picture, adjusts the RGB values, and then 
# repaints it
######################################################
def hw1(picture):
  show(picture)
  for p in getPixels(picture):
    value=getGreen(p)
    setGreen(p,value*1.25)
    value=getBlue(p)
    setBlue(p,value*.75)
    value=getRed(p)
    setRed(p,value*.25)
  repaint(picture)


######################################################
# Homework 2:
# rearranges a sound and makes the inserted part louder
######################################################
def hw2(file):
  source = makeSound(file)
  largest = 0
  for sourceIndex in range(33414,40052):
    largest = max(largest, getSampleValueAt(source, sourceIndex))
  multiplier = 32767.0/ largest
  for sourceIndex in range(33414, 40052):
    louder = multiplier * getSampleValueAt(source, sourceIndex)
    setSampleValueAt(source, sourceIndex,louder)

  target = makeSound(file)
  targetIndex=17408
  for sourceIndex in range(33414,40052):
    setSampleValueAt( target, targetIndex, getSampleValueAt(source,sourceIndex))
    targetIndex = targetIndex + 1
  for sourceIndex in range (17408, 26726):
    setSampleValueAt(target, targetIndex, getSampleValueAt(source,sourceIndex))
    targetIndex = targetIndex + 1
  for index in range(1,1000):
    setSampleValueAt(target, targetIndex,0)
    targetIndex = targetIndex + 1
  play(target)
  return target

######################################################
# Homework 3:
# creates a collage from a canvas and lays over some 
# manipulated images.
######################################################
def hw3():
  flower1=makePicture(getMediaPath("flower1.jpg"))
  canvasf=makePicture(getMediaPath("7inX95in.jpg"))
  targetX=1
  for sourceX in range(1,getWidth(flower1)):
    targetY=50
    for sourceY in range(1,getHeight(flower1)):
      px=getPixel(flower1,sourceX,sourceY)
      cx=getPixel(canvasf,targetX,targetY)
      setRed(px,0)
      setColor(cx,getColor(px))
      targetY=targetY + 1
    targetX=targetX + 1  
  targetX=200
  for sourceX in range(1,getWidth(flower1)):
    targetY=1
    for sourceY in range(1,getHeight(flower1)):
      color=getColor(getPixel(flower1,sourceX,sourceY))
      setColor(getPixel(canvasf,targetY,targetX),color)
      targetY=targetY + 1
    targetX=targetX + 1
  targetX=1
  for sourceX in range(1,getWidth(flower1)):
    targetY=315
    for sourceY in range(1,getHeight(flower1)):
      px=getPixel(flower1,sourceX,sourceY)
      cx=getPixel(canvasf,targetX,targetY)
      setColor(cx,getColor(px))
      targetY=targetY + 1
    targetX=targetX + 1  
  show(canvasf)
  return canvasf


######################################################
# Homework 4:
# Creates a page of links to a set of pictures in 
# the given directory
######################################################
def hw4(directory):
  linksfile=open(directory+"//index.html","wt")
  linksfile.write(doctype())
  linksfile.write(title("Samples from "+directory))
  samples="<h1>Samples from "+directory+" </h1>\n"
  for file in os.listdir(directory):
    if file.endswith(".jpg"):
      samples=samples+"<p>Filename: "+file
      samples=samples+'<a href="'+file+'"><image src="'+file+'" height="100" /></a></p>\n'
  linksfile.write(body(samples))
  linksfile.close()

def doctype():
  return '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transition//EN" "http://wwww.w3.org/TR/html4/loose.dtd">'

def title(titlestring):
  return "<html><head><title>"+titlestring+"</title></head>"

def body(bodystring):
  return "<body>"+bodystring+"</body></html>"

######################################################
# Homework 5:
# Makes a movie of a drawn shape moving around and a
# picture moving around
######################################################
def hw5(directory):
  for frame in range(0,100):
    canvas=  makePicture(getMediaPath("640x480.jpg"))
    canvas = func1(frame,canvas)
    canvas = func2(frame,canvas)
    writeFrame2(frame,canvas,directory)
def func1(frame,canvas):
  if frame<50:
    addRectFilled(canvas,frame*10,frame*5,50,50,red)
  if frame>=50:
    addRectFilled(canvas,(50-(frame-50))*10,(50-(frame-50))*5,50,50,red)
  return canvas 
def func2(frame,canvas):
  barbf=getMediaPath("barbara.jpg")
  barb =makePicture(barbf)
  sourceX = 45
  for targetX in range(frame*3,frame*3+((200-45)/2)):
    sourceY = 25
    for targetY in range(frame*3,frame*3+((200-25)/2)):
      color = getColor(getPixel(barb,int(sourceX),int(sourceY)))
      setColor(getPixel(canvas,targetX,targetY), color)
      sourceY = sourceY + 2
    sourceX = sourceX + 2
  return canvas
def writeFrame2(num,framepict,directory):
    framenum=str(num)
    #if num < 10:
      #writePictureTo(framepict,directory+"//frame00"+framenum+".jpg")
    #if num >= 10 and num<100:
      #writePictureTo(framepict,directory+"//frame0"+framenum+".jpg")
    #if num >= 100:
      #writePictureTo(framepict,directory+"//frame"+framenum+".jpg")


######################################################
# Homework 6:
# Downloads some headlines from CNN.com and makes a
# scrolling marquee movie of them. 
######################################################
def hw6(directory):
  connection = urllib.urlopen("http://www.cnn.com")
  headline= connection.read()
  connection.close()
  headloc = headline.find('<div class="cnnMainNewT2">')
  if headloc <> -1:
    endline = headline.find("</a>",headloc)
    beginline = headline.rfind(">",0,endline)
    story1=headline[beginline+1:endline]
  headloc = headline.find('<div class="cnnMainNewT2">',endline)
  if headloc <> -1:
    endline = headline.find("</a>",headloc)
    beginline = headline.rfind(">",0,endline)
    story2=headline[beginline+1:endline]
    headloc = headline.find('<div class="cnnMainNewT2">',endline)
  if headloc <> -1:
    endline = headline.find("</a>",headloc)
    beginline = headline.rfind(">",0,endline)
    story3=headline[beginline+1:endline]
  if headloc == -1:
    print ""
  for frame in range(0,100): 
    canvas = makePicture(getMediaPath("640x480.jpg"))
    addText(canvas,600-(frame*5),100,story1)   
    addText(canvas,600-(frame*5),200,story2) 
    addText(canvas,600-(frame*5),300,story3) 
    writeFrame(frame,directory,canvas)
def writeFrame(num,directory,framepict):
    framenum = str(num)
    if num < 10:
      writePictureTo(framepict, directory + "//frame0" + framenum + ".jpg")
    if num >= 10:
      writePictureTo(framepict, directory + "//frame" + framenum + ".jpg")







